'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.createFarm = exports.startFarm = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _logger = require('./logger');
var _pluralize = require('pluralize');var _pluralize2 = _interopRequireDefault(_pluralize);
var _jestWorker = require('jest-worker');var _jestWorker2 = _interopRequireDefault(_jestWorker);
var _pSettle = require('p-settle');var _pSettle2 = _interopRequireDefault(_pSettle);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const startFarm = exports.startFarm = function startFarm(config, configPath) {let options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};let workers = arguments[3];
    config = Array.isArray(config) ? config : [config];
    const silent = !!options.json;

    if (!silent) {
        (0, _logger.info)(
        'Building %s %s',
        _chalk2.default.yellow(config.length),
        (0, _pluralize2.default)('target', config.length));

    }

    const builds = config.map((c, i) =>
    workers.build(configPath, options, i, config.length));


    if (options.bail) {
        return Promise.all(builds);
    } else {
        return (0, _pSettle2.default)(builds).then(results =>
        Promise.all(
        results.map(
        result =>
        result.isFulfilled ?
        result.value :
        Promise.reject(result.reason))));



    }
};

const createFarm = exports.createFarm = farmOptions =>
new _jestWorker2.default(require.resolve('./webpackWorker'), _extends({
    forkOptions: {
        stdio: [0, 1, 2, 'ipc'] } },

farmOptions));