'use strict';var _fs = require('fs');var _fs2 = _interopRequireDefault(_fs);
var _interpret = require('interpret');
var _logger = require('./logger');function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const potentialExtensions = ['', ...Object.keys(_interpret.jsVariants)];

const checkWithAccess = path => {
    try {
        _fs2.default.accessSync(path);
        return true;
    } catch (ignore) {
        return false;
    }
};

const checkWithStatSync = path => {
    try {
        var stats = _fs2.default.statSync(path);
        return stats.isFile();
    } catch (ignore) {
        return false;
    }
};

const exists = path =>
_fs2.default.accessSync ? checkWithAccess(path) : checkWithStatSync(path);

module.exports = configPath => {
    const ext = potentialExtensions.find(ext => exists(configPath + ext));
    // can be extensionless
    if (ext !== undefined) {
        return configPath + ext;
    }
    throw new Error((0, _logger.decorate)('File does not exist', 'red'));
};