'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.getMatchingLoader = exports.availableExtensions = undefined;var _interpret = require('interpret');
var _lodash = require('lodash');
var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const availableExtensions = exports.availableExtensions = Object.keys(_interpret.jsVariants).sort((a, b) => {
    // sort extensions to ensure that .babel.js and
    // similar ones are always matched before .js
    const res = -(a.split(/\./).length - b.split(/\./).length);
    // all things being equal, we need to
    // prioritize .js as it is most likely
    if (res === 0) {
        if (a === '.js') {
            return -1;
        }
        if (b === '.js') {
            return 1;
        }
        return 0;
    }
    return res;
});

const getMatchingLoader = exports.getMatchingLoader = function getMatchingLoader(
configPath)


{let extensions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : availableExtensions;let variants = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _interpret.jsVariants;
    const ext = extensions.find(ext => (0, _lodash.endsWith)(configPath, ext));
    return ext ? variants[ext] : null;
};

const callConfigFunction = fn =>
fn(require('minimist')(process.argv, { '--': true }).env || {});

const getConfig = configPath => {
    const configModule = require(configPath);
    const configDefault =
    configModule && configModule.__esModule ?
    configModule.default :
    configModule;
    return typeof configDefault === 'function' ?
    callConfigFunction(configDefault) :
    configDefault;
};exports.default =

function (configPath) {let getMatchingLoaderFn = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : getMatchingLoader;
    const mod = getMatchingLoaderFn(configPath);

    if (mod) {
        const mods = Array.isArray(mod) ? mod : [mod];
        const installed = mods.some(mod => {
            if (typeof mod === 'string') {
                try {
                    require(mod);
                    return true;
                } catch (ignored) {}
            } else if (typeof mod === 'object') {
                try {
                    var s = require(mod.module);
                    mod.register(s);
                    return true;
                } catch (ignored) {}
            }
        });

        if (!installed) {
            throw new Error(
            'Could not load required module loading for ' +
            _chalk2.default.underline(configPath));

        }
    }
    return getConfig(configPath);
};