'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.loadConfig = exports.validateOptions = undefined;var _ajv = require('ajv');var _ajv2 = _interopRequireDefault(_ajv);
var _schema = require('../schema.json');var _schema2 = _interopRequireDefault(_schema);
var _loadConfigurationFile = require('./loadConfigurationFile');var _loadConfigurationFile2 = _interopRequireDefault(_loadConfigurationFile);
var _logger = require('./logger');
var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const validateOptions = exports.validateOptions = farmOptions => {
    const validate = new _ajv2.default({
        allErrors: true,
        coerceTypes: true,
        removeAdditional: 'all',
        useDefaults: true }).
    compile(_schema2.default);

    if (!validate(farmOptions)) {
        const errorMessage = validate.errors.
        map((_ref) => {let dataPath = _ref.dataPath,message = _ref.message;
            return `Property: "options ${dataPath}" ${message}`;
        }).
        join('\n');
        return Promise.reject(
        `Options validation failed:
            ${errorMessage}
            `);

    }
    return Promise.resolve('Options validation succeeded.');
};
const loadConfig = exports.loadConfig = (configPath, options) => {
    const argvBackup = process.argv;
    try {
        process.argv = options.argv;
        const config = (0, _loadConfigurationFile2.default)(configPath);
        process.argv = argvBackup;
        return Promise.resolve(config);
    } catch (e) {
        process.argv = argvBackup;
        return Promise.reject(
        new Error(
        (0, _logger.decorate)(
        `Could not load configuration file ${_chalk2.default.underline(
        configPath)
        } \n ${e}`,
        'red')));



    }
};